# Copyright (C) 2009 Aren Olson
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
# The developers of the Exaile media player hereby grant permission 
# for non-GPL compatible GStreamer and Exaile plugins to be used and 
# distributed together with GStreamer and Exaile. This permission is 
# above and beyond the permissions granted by the GPL license by which 
# Exaile is covered. If you modify this code, you may extend this 
# exception to your version of the code, but you are not obligated to 
# do so. If you do not wish to do so, delete this exception statement 
# from your version.

from tests.base import BaseTestCase
from xl import dynamic, collection

import lastfmdynamic

class LastFMDymamic(BaseTestCase):
    def setUp(self):
        BaseTestCase.setUp(self)

        self.dm = dynamic.DynamicManager(collection.Collection('Test'))
        self.plugin = self.load_plugin('lastfmdynamic')
        self.plugin.enable(self)

    def testFindSimilarArtists(self):
        
        items = self.dm.find_similar_artists({
            'artist': ['Hooverphonic'],
            'album': ['A New Stereophonic Sound Spectacular'],
        })

        assert len(items) > 2, "Similar artist search failed"
